local M = {}
local max_steer = 500
local angles_click = {180,370,580}
local angles_off = {120,180,360}
local tickSnd = nil
local tickVolume = 10
local soundNode = 0

local function onInit(jbeamData)
  isWarning = false

  --if jbeamData.soundNode_nodes and type(jbeamData.soundNode_nodes) == "table" and type(jbeamData.soundNode_nodes[1]) == "number" then
  --  soundNode = jbeamData.soundNode_nodes[1]
  --else
  --  soundNode = 0
  --end
  
  tickSnd = obj:createSFXSource2("event:>Vehicle>Interior>Light>BM318_Off", "AudioDefaultLoop3D", "", 0, 0)
  tickVolume = 0.5
end

local function onReset()
	electrics.values['click1'] = 0
	electrics.values['click2'] = 0
	electrics.values['click3'] = 0
	electrics.values['steering_old'] = 0
end

local function updateGFX(dt)
	-- left: +1, right: -1
	local signal = -electrics.values['turnsignal']
	-- left: positive, right: negative
	local steer_pos = electrics.values['steering']
	local steer_pos_old = electrics.values['steering_old']
	if signal > 0.01 and steer_pos > 0 then
		if steer_pos > angles_click[1] and steer_pos_old < angles_click[1] then
			electrics.values['click1'] = 1
			electrics.values['steering_old'] = electrics.values['steering']
			sounds.playSoundSkipAI(tickSnd, tickVolume)
			--obj:setVolume(tickSnd, tickVolume)
			--obj:cutSFX(tickSnd)
			--obj:playSFX(tickSnd)
			print("click1 left!")
		end
		if steer_pos > angles_click[2] and steer_pos_old < angles_click[2] then
			electrics.values['click2'] = 1
			electrics.values['steering_old'] = electrics.values['steering']
			sounds.playSoundSkipAI(tickSnd, tickVolume)
			print("click2 left!")
		end
		if steer_pos > angles_click[3] and steer_pos_old < angles_click[3] then
			electrics.values['click3'] = 1
			electrics.values['steering_old'] = electrics.values['steering']
			sounds.playSoundSkipAI(tickSnd, tickVolume)
			print("click3 left!")
		end
	end
	if signal < -0.01 and steer_pos < 0 then
		if steer_pos < -angles_click[1] and steer_pos_old > -angles_click[1] then
			electrics.values['click1'] = 1
			electrics.values['steering_old'] = electrics.values['steering']
			sounds.playSoundSkipAI(tickSnd, tickVolume)
			print("click1 right!")
		end
		if steer_pos < -angles_click[2] and steer_pos_old > -angles_click[2] then
			electrics.values['click2'] = 1
			electrics.values['steering_old'] = electrics.values['steering']
			sounds.playSoundSkipAI(tickSnd, tickVolume)
			print("click2 right!")
		end
		if steer_pos < -angles_click[3] and steer_pos_old > -angles_click[3] then
			electrics.values['click3'] = 1
			electrics.values['steering_old'] = electrics.values['steering']
			sounds.playSoundSkipAI(tickSnd, tickVolume)
			print("click3 right!")
		end
		electrics.values['steering_old'] = electrics.values['steering']
	end
	if electrics.values['click3'] == 1 and signal > 0 and steer_pos < angles_off[3] then
		electrics.toggle_left_signal()
		electrics.values['click3'] = 0
		electrics.values['click2'] = 0
		electrics.values['click1'] = 0
	end
	if electrics.values['click2'] == 1 and signal > 0 and steer_pos < angles_off[2] then
		electrics.toggle_left_signal()
		electrics.values['click3'] = 0
		electrics.values['click2'] = 0
		electrics.values['click1'] = 0
	end
	if electrics.values['click1'] == 1 and signal > 0 and steer_pos < angles_off[1] then
		electrics.toggle_left_signal()
		electrics.values['click3'] = 0
		electrics.values['click2'] = 0
		electrics.values['click1'] = 0
	end
	if electrics.values['click3'] == 1 and signal < 0 and steer_pos > -angles_off[3] then
		electrics.toggle_right_signal()
		electrics.values['click3'] = 0
		electrics.values['click2'] = 0
		electrics.values['click1'] = 0
	end
	if electrics.values['click2'] == 1 and signal < 0 and steer_pos > -angles_off[2] then
		electrics.toggle_right_signal()
		electrics.values['click3'] = 0
		electrics.values['click2'] = 0
		electrics.values['click1'] = 0
	end
	if electrics.values['click1'] == 1 and signal < 0 and steer_pos > -angles_off[1] then
		electrics.toggle_right_signal()
		electrics.values['click3'] = 0
		electrics.values['click2'] = 0
		electrics.values['click1'] = 0
	end
	electrics.values['steering_old'] = electrics.values['steering']
end

local function initSounds()
  beepLoop = obj:createSFXSource2(beepLoopName, "AudioDefaultLoop3D", "reverseBeep", soundNode, 0)
end

M.onInit    = onInit
M.initSounds = initSounds
M.onReset   = onReset
M.updateGFX = updateGFX

return M